package sluzby;

import java.beans.Beans;
import java.io.BufferedReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * Třída pro čtení souboru
 *
 * @author Matěj Fries
 */
public class Nacitac
{

    private final BufferedReader br;
    /**
     * List slov, které vrátí
     */
    private final List<String> slova;
    /**
     * Sloupec, ze kterého jsou data čtena
     */
    private final int sloupec;
    /**
     * Oddělovač hodnot v dokumentu
     */
    private final String oddelovac;

    /**
     * Konstruktor třídy
     *
     * @param br BufferedReader
     * @param sloupec, ze kterého jsou data čtena
     * @param oddelovac hodnot v dokumentu
     */
    public Nacitac(BufferedReader br, int sloupec, String oddelovac)
    {
        this.br = br;
        slova = new ArrayList<>();
        this.sloupec = sloupec;
        this.oddelovac = oddelovac;
    }

    /**
     * Metoda pro vlastní načtení dokumentu
     *
     * @return vrací list načtených slov
     */
    public List nacti()
    {
        try
        {
            String radek;
            String[] castiRadku;

            while ((radek = br.readLine()) != null)
            {
                castiRadku = radek.split(oddelovac);
                if (castiRadku.length >= sloupec)
                {
                    if (Beans.isInstanceOf(castiRadku[sloupec - 1], String.class))
                    {
                        slova.add(castiRadku[sloupec - 1]);
                    }
                }
            }

            return slova;

        } catch (IOException e)
        {
        }
        return slova;
    }

}
